﻿Morph subclass: #SkyRush
	instanceVariableNames: 'player keyState groundLevel kinect skelton score'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amino-SkyRush'!

!SkyRush methodsFor: 'accessing' stamp: 'qoo 6/14/2012 13:26'!
clear
	self inform: 'クリア～'.
	self delete!]lang[(40)0! !

!SkyRush methodsFor: 'accessing' stamp: 'qoo 6/14/2012 13:26'!
keyState
	^ keyState! !

!SkyRush methodsFor: 'accessing' stamp: 'Oomori 11/10/2012 14:48'!
missed
	self inform: 'score=' , score asString.
	self delete! !

!SkyRush methodsFor: 'accessing' stamp: 'qoo 6/14/2012 13:26'!
player
	^ player! !


!SkyRush methodsFor: 'submorphs-add/remove' stamp: 'qoo 10/25/2012 14:19'!
delete
	kinect stop.
	super delete! !


!SkyRush methodsFor: 'kinect' stamp: 'qoo 10/28/2012 12:39'!
doKinect
	| neck hand handr y x |
	skelton ifNil: [ ^ self ].
	neck := skelton jointNamed: #neck.
	neck ifNil: [ ^ self ].
	hand := skelton jointNamed: #l_hand.
	hand ifNil: [ ^ self ].
	handr := skelton jointNamed: #r_hand.
	handr ifNil: [ ^ self ].
	y := hand y - neck y.
	y < -0.05
		ifTrue: [ keyState add: #up ]
		ifFalse: [ keyState remove: #up ifAbsent: [  ] ].
	y > 0.05
		ifTrue: [ keyState add: #down ]
		ifFalse: [ keyState remove: #down ifAbsent: [  ] ].
	x := hand x - neck x.
	x < -0.05
		ifTrue: [ keyState add: #left ]
		ifFalse: [ keyState remove: #left ifAbsent: [  ] ].
	x > 0.05
		ifTrue: [ keyState add: #right ]
		ifFalse: [ keyState remove: #right ifAbsent: [  ] ].
	y := handr y - neck y.
	y < -0.05
		ifTrue: [ keyState add: #z ]
		ifFalse: [ keyState remove: #z ifAbsent: [  ] ].
	y > 0.05
		ifTrue: [ keyState add: #x ]
		ifFalse: [ keyState remove: #x ifAbsent: [  ] ]! !

!SkyRush methodsFor: 'kinect' stamp: 'EiichiroIto 10/24/2012 17:02'!
setupKinect
	kinect := KinectOSC new.
	kinect
		createSkeltonBlock: [ :skel | 
					skelton := skel.
					ActiveWorld flash ];
		deleteSkeltonBlock: [ :skel | skelton := nil ].
	kinect start! !


!SkyRush methodsFor: 'private' stamp: 'qoo 10/28/2012 12:48'!
fireCloud
	| b |
	b := SRCloud new.
	b center: bounds topRight + (0 @ 600 atRandom).
	self addMorphFront: b! !

!SkyRush methodsFor: 'private' stamp: 'qoo 10/28/2012 12:49'!
fireCloud2
	| b |
	b := SRCloud2 new.
	b center: bounds topRight + (0 @ 600 atRandom).
	self addMorphFront: b! !

!SkyRush methodsFor: 'private' stamp: 'qoo 10/28/2012 13:13'!
fireMeteo
	| b |
	b := SRMeteo new.
	b center: bounds bottomRight - (0 @ (800 - groundLevel) atRandom).
	self addMorphBack: b! !

!SkyRush methodsFor: 'private' stamp: 'qoo 10/28/2012 13:14'!
fireMissile
	| b |
	b := SRMissile new.
	b bottomRight: bounds bottomRight - (0 @ groundLevel).
	self addMorphBack: b! !

!SkyRush methodsFor: 'private' stamp: 'qoo 10/25/2012 13:38'!
gamepad
	| xy b |
	xy := Sensor joystickXY: 1.
	xy y = 1023
		ifTrue: [ keyState add: #up ]
		ifFalse: [ keyState remove: #up ifAbsent: [  ] ].
	xy y = -1024
		ifTrue: [ keyState add: #down ]
		ifFalse: [ keyState remove: #down ifAbsent: [  ] ].
	xy x = 1023
		ifTrue: [ keyState add: #right ]
		ifFalse: [ keyState remove: #right ifAbsent: [  ] ].
	xy x = -1024
		ifTrue: [ keyState add: #left ]
		ifFalse: [ keyState remove: #left ifAbsent: [  ] ].
	b := Sensor joystickButtons: 1.
	b = 1
		ifTrue: [ keyState add: 4 ]
		ifFalse: [ keyState remove: 4 ifAbsent: [  ] ]! !

!SkyRush methodsFor: 'private' stamp: 'qoo 10/28/2012 13:32'!
generateGround
	| b |
	b := SRGround new.
	groundLevel := groundLevel + (-10 to: 10) atRandom.
	groundLevel > 500
		ifTrue: [ groundLevel := 500 ].
	groundLevel < 50
		ifTrue: [ groundLevel := 50 ].
	b extent: 6 @ groundLevel.
	b bottomRight: bounds bottomRight.
	self addMorphFront: b! !

!SkyRush methodsFor: 'private' stamp: 'qoo 10/28/2012 13:02'!
score: x
	score := score + x! !


!SkyRush methodsFor: 'event handling' stamp: 'Anonymous 6/14/2012 13:25'!
handlesKeyboard: anEvent
	^ true! !

!SkyRush methodsFor: 'event handling' stamp: 'Anonymous 6/14/2012 13:25'!
handlesMouseDown: anEvent
	^ true! !

!SkyRush methodsFor: 'event handling' stamp: 'qoo 6/21/2012 14:19'!
keyDown: anEvent
	| v |
	v := anEvent keyValue.
	v = 28
		ifTrue: [ keyState add: #left ].
	v = 29
		ifTrue: [ keyState add: #right ].
	v = 30
		ifTrue: [ keyState add: #up ].
	v = 31
		ifTrue: [ keyState add: #down ].
	v = 90
		ifTrue: [ keyState add: #z ]! !

!SkyRush methodsFor: 'event handling' stamp: 'qoo 6/28/2012 13:10'!
keyUp: anEvent
	| v |
	v := anEvent keyValue.
	v = 28
		ifTrue: [ keyState remove: #left ifAbsent: [  ] ].
	v = 29
		ifTrue: [ keyState remove: #right ifAbsent: [  ] ].
	v = 30
		ifTrue: [ keyState remove: #up ifAbsent: [  ] ].
	v = 31
		ifTrue: [ keyState remove: #down ifAbsent: [  ] ].
	v = 90
		ifTrue: [ keyState remove: #z ifAbsent: [  ] ]! !

!SkyRush methodsFor: 'event handling' stamp: 'Anonymous 6/14/2012 13:26'!
mouseDown: anEvent
	anEvent hand keyboardFocus: self! !


!SkyRush methodsFor: 'initialization' stamp: 'Oomori 11/10/2012 14:48'!
initialize
	super initialize.
	self
		color:
			(Color
				r: 0.1
				g: 0.6
				b: 0.9
				alpha: 1).
	self extent: ActiveWorld extent.
	keyState := Set new.
	groundLevel := 100.
	self setupKinect.
	self setup! !

!SkyRush methodsFor: 'initialization' stamp: 'qoo 10/28/2012 13:01'!
setup
	| b |
	player := SRPlayer new.
	player center: bounds topLeft + (320 @ 240).
	self addMorphFront: player.
	b := SRMissile new.
	b center: bounds bottomRight - (30 @ 48).
	self addMorphFront: b.
	score := 0! !


!SkyRush methodsFor: 'stepping and presenter' stamp: 'qoo 10/28/2012 12:34'!
step
	self doKinect.	"	self gamepad."
	self submorphs do: [ :each | each move ].
	self generateGround.
	20 atRandom = 1
		ifTrue: [ self fireMissile ].
	10 atRandom = 1
		ifTrue: [ self fireMeteo ].
	60 atRandom = 1
		ifTrue: [ self fireCloud ].
	60 atRandom = 1
		ifTrue: [ self fireCloud2 ]! !

!SkyRush methodsFor: 'stepping and presenter' stamp: 'qoo 6/14/2012 13:26'!
stepTime
	^ 100! !

!SkyRush methodsFor: 'stepping and presenter' stamp: 'qoo 6/14/2012 13:26'!
wantsSteps
	^ true! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

SkyRush class
	instanceVariableNames: ''!

!SkyRush class methodsFor: 'instance creation' stamp: 'qoo 6/14/2012 13:26'!
open
	| obj |
	obj := JackPot new.
	obj openInWorld! !


Morph subclass: #SRBeam
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amino-SkyRush'!

!SRBeam methodsFor: 'initialization' stamp: 'qoo 6/14/2012 14:15'!
initialize
	super initialize.
	self extent: 20 @ 2.
	self color: Color yellow! !


!SRBeam methodsFor: 'testing' stamp: 'qoo 7/5/2012 13:41'!
isIntersected: aPlayer
	^ false! !

!SRBeam methodsFor: 'testing' stamp: 'qoo 6/14/2012 13:53'!
isTreasure
	^ true! !


!SRBeam methodsFor: 'accessing' stamp: 'qoo 7/5/2012 13:55'!
move
	| p |
	p := self center.
	p := p + (40 @ 0).
	self center: p.
	(self bounds intersects: owner bounds) not
		ifTrue: [ 
			self delete.
			^ self ].
	self checkCollision! !

!SRBeam methodsFor: 'accessing' stamp: 'qoo 6/14/2012 13:53'!
solvePenetration: aPlayer
	aPlayer waitMoment.
	self delete.
	ActiveWorld flash! !


!SRBeam methodsFor: 'private' stamp: 'qoo 7/19/2012 14:04'!
checkCollision
	owner submorphs
		do: [ :each | 
			(each isIntersected: self)
				ifTrue: [ 
					each hitByBeam.
					self delete ] ]! !


Morph subclass: #SRMissile
	instanceVariableNames: 'form'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amino-SkyRush'!

!SRMissile methodsFor: 'initialization' stamp: 'qoo 7/12/2012 14:03'!
initialize
	super initialize.
	self extent: 16 @ 48.
	self color: Color red.
	form := Form fromFileNamed: 'Missile!!.png'.
	form := form mapColor: Color white to: Color transparent! !


!SRMissile methodsFor: 'testing' stamp: 'qoo 6/28/2012 13:25'!
isIntersected: aPlayer
	^ self bounds intersects: aPlayer bounds! !

!SRMissile methodsFor: 'testing' stamp: 'qoo 6/28/2012 13:25'!
isTreasure
	^ false! !


!SRMissile methodsFor: 'accessing' stamp: 'qoo 10/28/2012 13:03'!
hitByBeam
	owner score: 1.
	self delete! !

!SRMissile methodsFor: 'accessing' stamp: 'qoo 7/12/2012 14:29'!
move
	| pos delta |
	owner isNil
		ifTrue: [ ^ self ].
	pos := self center.
	delta := -6 @ 0.
	pos x - owner player center x < 190
		ifTrue: [ delta := -6 @ -6 ].
	self center: pos + delta.
	(self bounds intersects: owner bounds) not
		ifTrue: [ self delete ]! !

!SRMissile methodsFor: 'accessing' stamp: 'qoo 6/28/2012 13:25'!
solvePenetration: aPlayer
	aPlayer owner missed! !


!SRMissile methodsFor: 'drawing' stamp: 'qoo 7/12/2012 14:01'!
drawOn: aCanvas
	aCanvas translucentImage: form at: self topLeft! !


Morph subclass: #SRCloud
	instanceVariableNames: 'form'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amino-SkyRush'!

!SRCloud methodsFor: 'initialization' stamp: 'qoo 10/28/2012 12:06'!
initialize
	super initialize.
	self extent: 120 @ 96.
	self color: Color white.
	form := Form fromFileNamed: 'Cloud.png'.
	form := form mapColor: Color white to: Color transparent! !


!SRCloud methodsFor: 'testing' stamp: 'qoo 10/28/2012 11:30'!
isIntersected: aPlayer
	^ false! !

!SRCloud methodsFor: 'testing' stamp: 'qoo 10/27/2012 11:00'!
isTreasure
	^ false! !


!SRCloud methodsFor: 'accessing' stamp: 'qoo 10/27/2012 11:00'!
hitByBeam
	! !

!SRCloud methodsFor: 'accessing' stamp: 'qoo 10/28/2012 12:50'!
move
	| pos delta |
	owner isNil
		ifTrue: [ ^ self ].
	pos := self center.
	delta := -5 @ 0.
	self center: pos + delta.
	(self bounds intersects: owner bounds) not
		ifTrue: [ self delete ]! !

!SRCloud methodsFor: 'accessing' stamp: 'qoo 10/27/2012 11:00'!
solvePenetration: aPlayer
	aPlayer owner missed! !

!SRCloud methodsFor: 'accessing' stamp: 'qoo 10/28/2012 11:30'!
wantsToBeTopmost
	^ true! !


!SRCloud methodsFor: 'drawing' stamp: 'qoo 10/28/2012 12:03'!
drawOn: aCanvas
	aCanvas translucentImage: form at: self topLeft! !


Morph subclass: #SRCloud2
	instanceVariableNames: 'form'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amino-SkyRush'!

!SRCloud2 methodsFor: 'initialization' stamp: 'qoo 10/28/2012 12:55'!
initialize
	super initialize.
	self extent: 390 @ 315.
	self color: Color white.
	form := Form fromFileNamed: 'Cloud2.png'.
	form := form mapColor: Color white to: Color transparent! !


!SRCloud2 methodsFor: 'testing' stamp: 'qoo 10/28/2012 12:17'!
isIntersected: aPlayer
	^ false! !

!SRCloud2 methodsFor: 'testing' stamp: 'qoo 10/28/2012 12:17'!
isTreasure
	^ false! !


!SRCloud2 methodsFor: 'accessing' stamp: 'qoo 10/28/2012 12:17'!
hitByBeam
	! !

!SRCloud2 methodsFor: 'accessing' stamp: 'qoo 10/28/2012 12:17'!
move
	| pos delta |
	owner isNil
		ifTrue: [ ^ self ].
	pos := self center.
	delta := -10 @ 0.
	self center: pos + delta.
	(self bounds intersects: owner bounds) not
		ifTrue: [ self delete ]! !

!SRCloud2 methodsFor: 'accessing' stamp: 'qoo 10/28/2012 12:17'!
solvePenetration: aPlayer
	aPlayer owner missed! !

!SRCloud2 methodsFor: 'accessing' stamp: 'qoo 10/28/2012 12:17'!
wantsToBeTopmost
	^ true! !


!SRCloud2 methodsFor: 'drawing' stamp: 'qoo 10/28/2012 12:17'!
drawOn: aCanvas
	aCanvas translucentImage: form at: self topLeft! !


Morph subclass: #SRGround
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amino-SkyRush'!

!SRGround methodsFor: 'initialization' stamp: 'qoo 7/19/2012 13:19'!
initialize
	super initialize.
	self extent: 6 @ 40.
	self color: Color brown! !


!SRGround methodsFor: 'testing' stamp: 'qoo 7/19/2012 13:12'!
isIntersected: aPlayer
	^ self bounds intersects: aPlayer bounds! !

!SRGround methodsFor: 'testing' stamp: 'qoo 7/19/2012 13:12'!
isTreasure
	^ false! !


!SRGround methodsFor: 'accessing' stamp: 'qoo 7/19/2012 14:05'!
hitByBeam
	! !

!SRGround methodsFor: 'accessing' stamp: 'qoo 7/19/2012 13:20'!
move
	| pos delta |
	owner isNil
		ifTrue: [ ^ self ].
	pos := self center.
	delta := -6 @ 0.
	self center: pos + delta.
	(self bounds intersects: owner bounds) not
		ifTrue: [ self delete ]! !

!SRGround methodsFor: 'accessing' stamp: 'qoo 7/19/2012 13:12'!
solvePenetration: aPlayer
	aPlayer owner missed! !


Morph subclass: #SRMeteo
	instanceVariableNames: 'form'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amino-SkyRush'!

!SRMeteo methodsFor: 'initialization' stamp: 'qoo 10/27/2012 10:55'!
initialize
	super initialize.
	self extent: 24 @ 24.
	self color: Color red.
	form := Form fromFileNamed: 'Meteo.png'.
	form := form mapColor: Color white to: Color transparent! !


!SRMeteo methodsFor: 'testing' stamp: 'qoo 7/5/2012 14:11'!
isIntersected: aPlayer
	^ self bounds intersects: aPlayer bounds! !

!SRMeteo methodsFor: 'testing' stamp: 'qoo 7/5/2012 14:11'!
isTreasure
	^ false! !


!SRMeteo methodsFor: 'accessing' stamp: 'qoo 7/19/2012 14:05'!
hitByBeam
	! !

!SRMeteo methodsFor: 'accessing' stamp: 'qoo 10/28/2012 12:50'!
move
	| pos delta |
	owner isNil
		ifTrue: [ ^ self ].
	pos := self center.
	delta := -30 @ 0.
	self center: pos + delta.
	(self bounds intersects: owner bounds) not
		ifTrue: [ self delete ]! !

!SRMeteo methodsFor: 'accessing' stamp: 'qoo 7/5/2012 14:11'!
solvePenetration: aPlayer
	aPlayer owner missed! !


!SRMeteo methodsFor: 'drawing' stamp: 'qoo 10/27/2012 10:56'!
drawOn: aCanvas
	aCanvas translucentImage: form at: self topLeft! !


Morph subclass: #SRPlayer
	instanceVariableNames: 'wait nextWait form'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Amino-SkyRush'!

!SRPlayer methodsFor: 'private' stamp: 'qoo 7/5/2012 13:28'!
checkCollision
	owner submorphs
		do: [ :each | 
			(each isIntersected: self)
				ifTrue: [ each solvePenetration: self ] ]! !

!SRPlayer methodsFor: 'private' stamp: 'qoo 6/14/2012 13:31'!
waitMoment
	wait := nextWait.
	nextWait := nextWait + 10! !


!SRPlayer methodsFor: 'initialization' stamp: 'qoo 7/12/2012 14:05'!
initialize
	super initialize.
	self extent: 48 @ 16.
	self color: Color blue.
	wait := 0.
	nextWait := 10.
	form := Form fromFileNamed: 'Player!!.png'.
	form := form mapColor: Color white to: Color transparent! !


!SRPlayer methodsFor: 'testing' stamp: 'qoo 6/14/2012 13:31'!
isIntersected: aPlayer
	^ false! !

!SRPlayer methodsFor: 'testing' stamp: 'qoo 6/14/2012 13:31'!
isTreasure
	^ false! !


!SRPlayer methodsFor: 'accessing' stamp: 'qoo 7/19/2012 14:14'!
move
	| pos keyState b |
	keyState := owner keyState.
	pos := self center.
	(keyState includes: #left)
		ifTrue: [ pos := -10 @ 0 + pos ].
	(keyState includes: #right)
		ifTrue: [ pos := 10 @ 0 + pos ].
	(keyState includes: #up)
		ifTrue: [ pos := 0 @ -10 + pos ].
	(keyState includes: #down)
		ifTrue: [ pos := 0 @ 10 + pos ].
	(keyState includes: #z)
		ifTrue: [ 
			b := SRBeam new.
			b center: bounds topLeft + (55 @ 9).
			owner addMorphFront: b ].
	wait = 0
		ifTrue: [ self center: pos ]
		ifFalse: [ wait := wait - 1 ].
	self checkCollision! !


!SRPlayer methodsFor: 'drawing' stamp: 'qoo 7/12/2012 13:59'!
drawOn: aCanvas
	aCanvas translucentImage: form at: self topLeft! !
